<template>
  <v-container>
    <h1 class="display-1 my-3 font-weight-bold">
      Referral Program
    </h1>
    <span v-text="data ? data.description : ''" />
    <!-- eslint-disable-next-line vue/no-v-html -->
    <article v-html="data ? data.content : ''" />
    <v-card flat max-width="600" class="mx-auto my-4">
      <v-card-title class="text-center d-block font-weight-medium py-1">
        <v-sheet tile color="accent" class="py-3 mb-2 white--text">
          Refer a Friend
        </v-sheet>
      </v-card-title>
      <v-card-text class="py-2">
        <v-form v-model="isValid">
          <v-row dense>
            <v-col cols="6">
              <v-text-field v-model="form.firstName" outlined label="Your first name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.lastName" outlined label="Your last name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.email" outlined label="Your email*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.phone" outlined label="Your phone number*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.referFirtName" outlined label="Referral First name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.referLastName" outlined label="Referral Last name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.referEmail" outlined type="email" label="Referral Email*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.referPhone" outlined type="tel" label="Referral Phone*" />
            </v-col>
          </v-row>
        </v-form>
      </v-card-text>
      <v-card-actions class="flex-column py-0">
        <v-btn color="accent" :loading="sending" block depressed @click="send">
          Send
        </v-btn>
      </v-card-actions>
      <v-alert :value="showSent" prominent type="success" class="display-1 px-5">
        Sent
      </v-alert>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'

export default defineComponent({
  setup (_, { root }) {
    const form = ref({
      firstName: '',
      lastName: '',
      email: '',
      phone: '',
      referFirtName: '',
      referLastName: '',
      referEmail: '',
      referPhone: ''
    })
    const data = ref(root.$store.getters.getConfiguration('referral-program'))
    const isValid = ref(false)
    const sending = ref(false)
    const showSent = ref(false)

    const send = async () => {
      sending.value = true
      await root.$axios.post('/messages', {
        ...form.value,
        type: 'contact-form'
      })
      sending.value = false
      showSent.value = true
      setTimeout(() => {
        showSent.value = false
      }, 1500)
    }
    return {
      data,
      send,
      isValid,
      form,
      sending,
      showSent
    }
  }
})
</script>
